
import java.io.*;

public class writelong {
    
    public static void write_uint(int u, byte[] output_array) {
	for (int i = 3; i >= 0; i--) {
	    output_array[i] = (byte)u;
	    u = (u >> 8);
	}
    }


    public static void write_uint_java(int u, byte[] output_array) {
	ByteArrayOutputStream out=new ByteArrayOutputStream();
	DataOutputStream o=new DataOutputStream(out);
	try {
	    o.writeInt(u);
	    o.flush();	    
	    byte[] bytes=out.toByteArray();
	    for(int i=0; i < bytes.length; i++)
		output_array[i]=bytes[i];
	}
	catch(Exception e) {
	    System.err.println(e);
	}	
    }



    public static int read_uint(byte[] pBytes) { 
	int tmpInt = (int)pBytes[0];
	for(int i=1;i<4;i++) {
	    tmpInt = (tmpInt << 8);
	    tmpInt |= pBytes[i];
	}	
	return tmpInt;
    }




//     public static int read_uint(byte[] b) {
// 	int retval=0, tmp;

// 	for(int i=0; i < b.length; i++)
// 	    System.out.println("b[i]: " + b[i]);

	
// 	int b1=b[0], b2=b[1], b3=b[2], b4=b[3];

	
// 	if(b1 < 0) b1=256+b1;
// 	if(b2 < 0) b2=256+b2;
// 	if(b3 < 0) b3=256+b3;
// 	if(b4 < 0) b4=256+b4;
       
	
// 	System.out.println( b1 + " " + b2 + " " + 
// 			    b3 + " " + b4);
	
// 	System.out.println((b1 << 24) + " " + (b2 << 16) + " " + 
// 			   (b3 << 8) + " " + b4);


// 	retval=(b1 << 24) + (b2 << 16) + (b3 << 8) + b4;
// 	return retval;
//     }



    public static int read_uint_java(byte[] input_array) {
	ByteArrayInputStream in=new ByteArrayInputStream(input_array);
	DataInputStream i=new DataInputStream(in);
	try {
	    int tmp=i.readInt();
	    return tmp;
	}
	catch(Exception e) {
	    System.err.println(e);
	    return 0;
	}	
    }



    public static void print_array(byte[] arr) {
	for(int i=0; i < arr.length; i++)
	    System.out.print((int)arr[i] + " ");
	System.out.println("");
    }

    public static void clear_array(byte arr[]) {
	for(int i=0; i < arr.length; i++)
	    arr[i]='\0';
    }


    public static boolean check_array(byte[] arr1, byte[] arr2) {
	byte a, b;
	for(int i=0; i < arr1.length; i++) {
	    a=arr1[i];
	    b=arr2[i];
	    if(a != b)
		return false;
	}
	return true;
    }



    public static void main(String args[]) {

	byte arr1[]=new byte[4];
	byte arr2[]=new byte[4];

	for(int i=0; i < 100000; i++) {
	    write_uint(i, arr1);
	    write_uint_java(i, arr2);
	    if(check_array(arr1, arr2) == false) {
		System.err.println("Number " + i + " failed");
		return;
	    }
	    System.out.println(i);
	}


    }

}
